import json
import os
import threading


def subtract(a, b):
    return [*(item for item in a if item not in b)]


def union_two(a, b):
    (m, n) = (len(a), len(b))
    i = j = 0

    # Destination Array
    d = []

    # Merge from a and b together
    while i < m and j < n:
        if a[i] <= b[j]:
            d.append(a[i])
            i += 1
        else:
            d.append(b[j])
            j += 1

    # Merge from a if b has run out
    while i < m:
        d.append(a[i])
        i += 1

    # Merge from b if a has run out
    while j < n:
        d.append(b[j])
        j += 1

    return d


def normalize_list(lst):
    if type(lst) == dict:
        return list(lst.values())
    elif type(lst) == list:
        return lst


def union(inp):
    n = len(inp)
    vl = normalize_list(inp)
    while n >= 2:
        if n == 2:
            vl = union_two(vl[0], vl[1])
        elif n > 2:
            tmp = list()
            tmp.append(vl[n - 1])
            vl = union(vl[0: n - 2])
            tmp.append(vl)
            vl = tmp
        n = n - 1
    return vl


def intersect(lst1, lst2):
    return list(set(lst1) & set(lst2))


def operations(inp):
    flag = []
    if "AND" in inp:
        flag.append("&")
    elif "NOT" in inp:
        flag.append("!")
    return flag


def get_info(inp):
    result = list()
    if type(inp) == dict:
        key_list = inp.keys()
        for word in key_list:
            for docID in inp.get(word):
                result.append(docID)
    elif type(inp) == list:
        result = inp

    # Reading docs from docs dictionary.
    out = list()
    for docID in result:
        file = open(f"./docs/{docID}.json", "r", encoding="utf-8")
        cnt = json.load(file)
        cnt = dict(cnt)
        val = cnt.values()
        out.append(list(val))
        file.close()

    return out


# Get dictionary of docIDs and return the title of most relevant.
def __write_logs(string):
    file = open(f"./logs/log.txt", "a", encoding="utf-8")
    file.write(string + "\n")
    file.close()


def __intersection(i: int, return_list: list, selected: list):
    if i == 0:
        for doc in range(0, len(selected)):
            return_list.append(selected[doc])
    else:
        counter = 0
        while counter < len(return_list):
            if not selected.__contains__(return_list[counter]):
                return_list.remove(return_list[counter])
                counter = counter - 1
            counter = counter + 1
    return return_list


def __double_quotation(i: int, query: list, dictionary: dict, finish: bool, doc_id: list):
    length = len(query[i])
    query[i] = query[i][1:length]  # length of phrase query.
    if dictionary.keys().__contains__(query[i]):
        while True:  # Find end of "
            selected = list()
            length = len(query[i + 1])
            if query[i][length - 1] == '"':
                query[i + 1] = query[i + 1][0:length - 1]
                finish = True

            #   Find docID
            for aP in range(0, len(dictionary[query[i]])):
                # document ID
                doc = list(dictionary[query[i]].keys())[aP]  # Number of document in dictionary.
                if dictionary[query[i + 1]].keys().__contains__(doc):

                    # Array of this word in the query.
                    presentPointer = dictionary[query[i]][doc]

                    # Array of next word in query.
                    nextPointer = list()
                    for bP in range(0, len(dictionary[query[i + 1]][doc])):  # Iterate from end to begin.
                        nextPointer.append(dictionary[query[i + 1]][doc].__getitem__(bP) - 1)

                    # Position of documents.
                    for p in dictionary[query[i]][doc]:
                        if nextPointer.__contains__(dictionary[query[i]][doc].__getitem__(p)):
                            selected.append(doc)
                            break
            # intersect of documents.
            doc_id = __intersection(i, doc_id, selected)
            i = i + 1
            if finish:
                return doc_id
    else:
        return list()


def __not(i: int, query: list, dictionary: dict, doc_id: list):
    global file_numbers
    selected = list()
    length = len(query[i])
    query[i] = query[i][1:length]  # length of phrase query.
    if dictionary.keys().__contains__(query[i]):
        for term in range(0, file_numbers):
            if not dictionary.keys().__contains__(query[term]):
                selected.append(term)

    else:  # Not in dictionary.
        for pointer in range(0, file_numbers):
            selected.append(pointer)

    doc_id = __intersection(i, doc_id, selected)
    return doc_id


def __file_number():
    global file_numbers
    os.chdir("./docs")
    file_numbers = len(os.listdir())


def __simple_check(i: int, query: list, dictionary: dict, doc_id: list):
    global file_numbers
    selected = list()
    if dictionary.keys().__contains__(query[i]):
        for term in range(file_numbers):
            if dictionary[query[i]].keys().__contains__(term):
                selected.append(term)
        doc_id = __intersection(i, doc_id, selected)
    else:
        doc_id = list()
    return doc_id


file_numbers = 0


def __checker(query: list, dictionary: dict):
    finish = False
    i = 0  # For getting index of words in dictionary
    content = list()
    while i < len(query):
        if query[i][0] == '"':
            content = __double_quotation(i, query, dictionary, finish, content)

        elif query[i][0] == '!':
            content = __not(i, query, dictionary, content)
        else:
            content = __simple_check(i, query, dictionary, content)
        i = i + 1
    return content


def enter(it):
    t1 = threading.Thread(target=__write_logs, args=(it,))
    t1.start()
    t2 = threading.Thread(target=__file_number, args=())
    t2.start()
    spl = list(it.split(" "))
    file = open("./index/ii.json", "r", encoding="utf-8")
    index = json.load(file)
    dictionary = dict(index)
    rs = __checker(it, dictionary)

    ld = dict()
    for i in range(len(rs)):
        ld[rs[i]] = index.get(rs[i])
        print(ld[rs[i]])

    out_data = get_info(ld)
    t1.join()
    return out_data
